﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (this.textBox1.Text.Length == 0)
            {
                return;
            }

            DrawCode(this.textBox1.Text.Trim()[0]);
        }

        void DrawCode(char ch)
        {
            int width = 48;
            int height = 55;
            Bitmap bitmap = new Bitmap(width, height);
            Graphics g = Graphics.FromImage(bitmap);

            string text = ch.ToString();
            RectangleF rect = new RectangleF(0, 0, width, height);
            g.Clear(Color.White);
            g.DrawString(text, new Font("Consolas", 48, FontStyle.Regular, GraphicsUnit.Pixel), Brushes.Black, rect);
            g.Flush();

            StringBuilder sb = new StringBuilder();

            bool occurred = false;

            for (int y = 0; y < height; y++)
            {
                bool skip = true;
                StringBuilder line = new StringBuilder();
                for (int x = 0; x < width; x++)
                {
                    Color clr = bitmap.GetPixel(x, y);
                    if (clr.ToArgb() == Color.White.ToArgb())
                    {
                        line.Append(" ");
                    }
                    else
                    {
                        line.Append(text);
                        skip = false;
                        occurred = true;
                    }
                }

                if (skip == true && occurred == false)
                {
                    continue;
                }

                sb.Append(line.ToString() + Environment.NewLine);
            }

            this.panel1.BackgroundImageLayout = ImageLayout.Center;
            this.panel1.BackgroundImage = bitmap;

            this.textBox2.Text = sb.ToString();
        }
    }
}
